package com.muyu.cloud.etl.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.cloud.etl.mapper.SourceMapper;
import com.muyu.cloud.etl.service.SourceService;
import com.muyu.domain.Source;
import com.muyu.domain.req.SourceReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.util.List;

@Service
public class SourceServiceImpl extends ServiceImpl<SourceMapper, Source> implements SourceService {
    @Autowired
    private SourceMapper sourceMapper;

    @Override
    public List<Source> selectSourceList(SourceReq sourceReq) {
       return sourceMapper.selectSourceList(sourceReq);
    }

    @Override
    public Source getInfo(Long id) {
        LambdaQueryWrapper<Source> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.eq(Source::getId, id);
        return this.sourceMapper.selectOne(lambdaQueryWrapper);
    }

    //新增
    @Override
    public int insertBasicConfigInfo(Source sourceReq) {
        int insert = sourceMapper.insert(sourceReq);
        return insert;
    }

    @Override
    public Integer deleteByIds(String ids) {
        LambdaQueryWrapper<Source> lambdaQueryWrapper = new LambdaQueryWrapper<>();
        lambdaQueryWrapper.in(Source::getId, ids);
        int delete = sourceMapper.delete(lambdaQueryWrapper);
        return delete;
    }

    @Override
    public int updataSource(Source sourceReq) {
      Integer i=  sourceMapper.updataSource(sourceReq);
        return i;
    }

    @Override
    public int connectionTest(Source source) {
        String host = source.getHost();
        String port = source.getPort();
        String databaseName = source.getDatabaseName();
        String databaseType = source.getDatabaseType();
        String url = "jdbc:" + databaseType + "://" + host + ":" + port + "/" + databaseName + "?" + source.getConnectionParams();
        String user = source.getUsername();
        String password = source.getPassword();
        Connection conn = null;

        try {
            conn = DriverManager.getConnection(url, user, password);

        } catch (SQLException e) {
            throw new RuntimeException(e);
        }


        return  1;
    }

}
